#include "apc220cfg.h"

// just whoing how to embed embedded reprogram of apc220 in your program

// There is a hardware serial port and software serial version
//

// we need to create a software serial port
// we dont need to do it for the hardware serial ports
// bq they are already created in the runtime systems
// MORE COMMENTS IN BOTTOM OF FILE
//

SoftwareSerial soft01(10, 11);

// just an easy interface to configure an apc220 on the port

apc220cfg soft01cfg(&soft01, 8);
apc220cfg serialcfg(&Serial, 5);
// --------------------------^-- dig pin to force apc in prog mode
//--------------------^--------- reference to serial port


void drawRadio8to13();

 
char x[34];

char newx[]="412000 2 9 3 0";

void setup() {
	int res;
	// put your setup code here, to run once:
	Serial.begin(9600); // initalise 
	
	soft01.begin(9600); // initalise 
	
	// SOFTSERIAL
	//drawRadio8to13();  // just to show a "picture" of setup


	// SW config on pin 8 to 13
	// pin 13 i power
	// pin 12 is enable radio
	pinMode(13, OUTPUT);
	digitalWrite(13, HIGH); // power on
	
	pinMode(12, OUTPUT);
	digitalWrite(12, HIGH); // enable radio
    
    delay(300), // just to stabilize radio - way to long but ...

	// read present config

	res = soft01cfg.rdCfg(x); // returns 0 if ok, otherwise -1

	if (res == 0) {
		Serial.println(x);
	}
	else {
		Serial.print("no radio found");
		Serial.println(res);
	}

	// push new config

	serialcfg.wrCfg("412000 2 9 3 0");	
	//or  serialcfg.wrCfg(newx);
	
	// on serial port use serial.wrCfg etc
	// NB remember to have setup pin on radio connected to a dig pin
	
}

 

void loop() {}

void drawRadio8to13()
{
	Serial.println(F(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> "));
	Serial.println(F("Attach radio directly to Arduino on pin 8 to gnd as shown below"));
	Serial.println(F("or solder some wires so you can connect the radio on the shields"));
	Serial.println(F("to 8,10,11,13 and 14. Remove any jumpers on shield "));
	Serial.println(F(" "));
	Serial.println(F("  ---------------"));
	Serial.println(F("  |      A   aref"));
	Serial.println(F("  |      R    GND-++-GND---------------"));
	Serial.println(F("  |      D     13 ++ 5V               |=======antenna =======>"));
	Serial.println(F("  |      U     12 -- ENABLE(high)     |"));
	Serial.println(F("  |      I     11 ++ RX               |"));
	Serial.println(F("  |      N     10 ++ TX               |"));
	Serial.println(F("  5V     O     09 -- not used         |"));
	Serial.println(F("  GND          08-++ SET/CONFIG(low)--|"));
	Serial.println(F("  ---------------"));
	Serial.println(F("  |          ~ 07"));
	Serial.println(F("  |          ~ 06"));
	Serial.println(F("  |          ~ 05"));
	Serial.println(F("  |            04"));
	Serial.println(F("  |          ~ 03"));
	Serial.println(F("  |            02"));
	Serial.println(F("  |         TX 01"));
	Serial.println(F("  |         RX 00"));
	Serial.println(F("  ---------------"));
	Serial.println(F("Remember to connect5V(pin13) to 5V as p13 might no be able"));
	Serial.println(F("to give enough power for normal op"));
}

